/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end

_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         AddressPage_Close
*/
AddressPage_Close: 
    call AddressPage_Fini
return

/*:VRX         AddressPage_Create
*/
AddressPage_Create: 
    call AddressPage_Init
return

/*:VRX         AddressPage_Fini
*/
AddressPage_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window


return
/*:VRX         AddressPage_Init
*/
AddressPage_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window

    /* Initialize all the data entry fields */
    names = "Name Company Street City State ZIPCode"
    do n=1 to words(names)
      call VRSet word(names,n), "Value", value( word(names,n) )
    end
    call VRMethod "Name","SetFocus"  
return

/*:VRX         Fini
*/
Fini:
    names = "Name Company Street City State ZIPCode Telephone FAX Notes"
    do n=1 to words(names)
      value = VRGet( word(names,n), "Value" )  
      call value word(names,n), value
 /*     say word(names,n) "= '"value"'"  */
    end

    retvalue = saveData()
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window

return retvalue

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    window = VRWindow()
    call VRMethod window, "CenterWindow"

    call loadData initArgs.1
    call VRSet window, "Caption", Name

    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window

return

/*:VRX         loadData
*/
loadData: 
    
    /* Clear all field values */
    names = "Name Company Street Address City State ZIPCode Telephone FAX Notes"
    do n=1 to words(names)
        call value word(names,n), ""
    end

    /* parse the data record passed as arg(1) */
    parse value arg(1) with ';' Name ';' Icon ';' left ';' bottom ';' rem

    if Icon = "" then
        Icon = "PERSON.ICO"

    if left = "" then
        left = 100
    if bottom = "" then
        bottom = 100

    do while length(rem) > 0
     parse var rem field ';' value ';' rem
     call value strip(field), value   
    end

return

/*:VRX         NoteBookWindow_Close
*/
NoteBookWindow_Close:
    call Quit
return

/*:VRX         NotesPage_Close
*/
NotesPage_Close: 
    call NotesPage_Fini
return

/*:VRX         NotesPage_Create
*/
NotesPage_Create: 
    call NotesPage_Init
return

/*:VRX         NotesPage_Fini
*/
NotesPage_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window

return
/*:VRX         NotesPage_Init
*/
NotesPage_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window

    /* Initialize all the data entry fields */
    names = "Notes"
    do n=1 to words(names)
      call VRSet word(names,n), "Value", value( word(names,n) )
    end
    call VRMethod "Notes", "SetFocus"
return

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         saveData
*/
saveData: 
    record = ""
    names = "Name Company Street City State ZIPCode Telephone FAX Notes"
    do n=1 to words(names)
      record = record";"word(names,n)";"value( word(names,n) )
    end

    record = ";"Name";"Icon";"left";"bottom||record
return record

/*:VRX         TelephonePage_Close
*/
TelephonePage_Close: 
    call TelephonePage_Fini
return

/*:VRX         TelephonePage_Create
*/
TelephonePage_Create: 
    call TelephonePage_Init
return

/*:VRX         TelephonePage_Fini
*/
TelephonePage_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window

return
/*:VRX         TelephonePage_Init
*/
TelephonePage_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window

    /* Initialize all the data entry fields */
    names = "Telephone FAX"
    do n=1 to words(names)
      call VRSet word(names,n), "Value", value( word(names,n) )
    end
    call VRMethod "Telephone", "SetFocus"
return

