/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         Fini
*/
Fini:
    if VRGet("RB_COM1", "Set") then
        COMPort = "COM1:"
    else
        COMPort = "COM2:"
    BaudRate = VRGet("DDCB_BaudRate", "Value")
    DialString = VRGet("EF_DialString", "Value")
    HangupString = VRGet("EF_HangupString", "Value")
     
    ok = VRMethod("Application","PutVar", "COMPort")
    ok = VRMethod("Application", "PutVar", "BaudRate")
    ok = VRMethod("Application", "PutVar", "DialString")
    ok = VRMethod("Application", "PutVar", "HangupString")
    /* say "Options:Fini" COMPort BaudRate DIalString HangupString */
    
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:

    ok = VRMethod("Application","GetVar", "COMPort")
    ok = VRMethod("Application", "GetVar", "BaudRate")
    ok = VRMethod("Application", "GetVar", "DialString")
    ok = VrMethod("Application", "GetVar", "HangupString")
    /* say COMPORT BaudRate DIalString HangupString */

    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
return

/*:VRX         ModemOptions_Close
*/
ModemOptions_Close: 
    call ModemOptions_Fini
return

/*:VRX         ModemOptions_Create
*/
ModemOptions_Create: 
    call ModemOptions_Init
return

/*:VRX         ModemOptions_Fini
*/
ModemOptions_Fini: 

    if VRGet("RB_COM1", "Set") then
        COMPort = "COM1:"
    else
        COMPort = "COM2:"
    BaudRate = VRGet("DDCB_BaudRate", "Value")
    DialString = VRGet("EF_DialString", "Value")
    HangupString = VRGet("EF_HangupString", "Value")
    /* say "ModemOptions_Fini" COMPort BaudRate DialString HangupString */

    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         ModemOptions_Init
*/
ModemOptions_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window

    if COMPort = "COM1:" then
     do
        call VRSet "RB_COM1", "Set", 1
        call VRSet "RB_COM2", "Set", 0
        call VRMethod "RB_COM1", "SetFocus"
     end    
    else
     do
        call VRSet "RB_COM1", "Set", 0
        call VRSet "RB_COM2", "Set", 1
        call VRMethod "RB_COM2", "SetFocus"
     end        

    ok = VRSet("DDCB_BaudRate", "Value", BaudRate)
    ok = VRSet("EF_DialString", "Value", DialString)
    ok = VRSet("EF_HangupString", "Value", HangupString)
    
    
return

/*:VRX         Options_Close
*/
Options_Close:
    call Quit
return

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         RB_COM1_Click
*/
RB_COM1_Click: 
   ok = VRSet("RB_COM2", "Set", 0)
return

/*:VRX         RB_COM2_Click
*/
RB_COM2_Click: 
    ok = VRSet("RB_COM1","Set",0)
return

