/*:VRX         Main
*/
Main:
    signal on halt


exit

/*:VRX         getINIKeys
*/
getINIKeys: 

    AppName = "PhoneBook"       /* INI application name */
    INIFile = "PHONEBK.INI"     /* INI file name */
    COMPortKey = "COMPort"      /* INI key for comport */
    BaudRateKey = "BaudRate"    /* INI key for baudrate */
    DialStringKey = "DialString" /* INI key for dialing string */
    HangupStringKey = "HangupString" /* INI key for hangup string */
    LastFileKey = "LastFile"    /* INI key for last phonebook file used */

return

/*:VRX         Halt
*/
Halt:

exit

/*:VRX         ReadINI
*/
ReadINI: 
/************************************************************************    
 *   Get values from INI file - PHONEBK.INI or create it if necessary
 ************************************************************************
 */    
    call getINIkeys

    COMPort = VRGetIni( AppName, COMPortKey, INIFile, "NoClose" )
    if COMPort = "" then
     do
       COMPort = "COM1:"   
       BaudRate = "2400"
       DialString = "ATDT"
       HangupString = "ATH"
       FileName = "PHONEBK.PBK"
       ok = VRSetIni(AppName, COMPortKey, COMPort, INIFile, "NoClose")
       ok = VRSetIni(AppName, BaudRateKey, BaudRate, INIFile, "NoClose")
       ok = VRSetIni(AppName, DialStringKey, DialString, INIFile, "NoClose")
       ok = VRSetIni(AppName, HangupStringKey, HangupString, INIFile, "NoClose")

       ok = VRSetIni(AppName, LastFileKey, FileName, INIFile)
     end
    else
     do
        BaudRate = VRGetIni( AppName, BaudRateKey, INIFile, "NoClose")
        DialString = VRGetIni( AppName, DialStringKey, INIFile, "NoClose")
        HangupString = VRGetIni( AppName, HangupStringKey, INIFile, "NoClose")
        FileName = VRGetIni( AppName, LastFileKey, INIFile)
     end

    /* Set global variables so other files can get to them */
    call VRMethod "Application", "PutVar", "COMPort"
    call VRMethod "Application", "PutVar", "BaudRate"
    call VRMethod "Application", "PutVar", "DialString"
    call VRMethod "Application", "PutVar", "HangupString"
    call VRMethod "Application", "PutVar", "FileName"


return

/*:VRX         WriteINI
*/
WriteINI: 
/************************************************************************
 *   Save values in INI file - PHONEBK.INI or create it if necessary
 ************************************************************************
 */    

    call getINIkeys
    /* Get global variables values */
    call VRMethod "Application", "GetVar", "COMPort"
    call VRMethod "Application", "GetVar", "BaudRate"
    call VRMethod "Application", "GetVar", "DialString"
    call VRMethod "Application", "GetVar", "HangupString"
    call VRMethod "Application", "GetVar", "FileName"
    ok = VRSetIni(AppName, COMPortKey, COMPort, INIFile, "NoClose")
    ok = VRSetIni(AppName, BaudRateKey, BaudRate, INIFile, "NoClose")
    ok = VRSetIni(AppName, DialStringKey, DialString, INIFile, "NoClose")
    ok = VRSetIni(AppName, HangupStringKey, HangupString, INIFile, "NoClose")

    ok = VRSetIni(AppName, LastFileKey, FileName, INIFile)

return

